Subject: bug#37689: Fringe pixmaps, widgets, etc. look ridiculously tiny in hidpi screen

From: Alan Third <[email-masked]>
Date: Mon, 14 Oct 2019 14:19:55 +0100

On Mon, Oct 14, 2019 at 11:33:02AM +0300, Eli Zaretskii wrote:
> > From: Carlos Pita <[email-masked]>
> > Date: Sun, 13 Oct 2019 21:40:14 -0300
> > Cc: Robert Pluim <[email-masked]>, [email-masked]
> > 
> > 1.b. Do the scaling upstream (for example, in get_fringe_bitmap_data
> > as proposed above). One problem with this approach is that some
> > backend could already be scaling output itself (for example, by using
> > a toolkit that automatically scales according to the device
> > resolution... do you know if this is the case for windows, for
> > macos?). Also, it won't fix the widgets issue (anyway, as I said,
> > neither the "downstream" approach will do it in 26.3).
> 
> Granted, I prefer the second approach.  We should do as little code
> duplication as possible.
> 
> I don't think individual backends do any scaling, but if some do, it
> should be easy to disable the scaling in our code for those backends.

macOS automatically scales, so the UI code generally doesn’t need to
know that it’s running on a hi‐DPI screen. The only exception is
images where ideally the program presents an image that matches the
physical DPI of the screen, but the rest of the UI code behaves as if
the screen is half the DPI.

I think it should be easy to make it do the right thing here.
-- 
Alan Third